Bug 36815 - Improve PRINTING capabilities of comments/notes: add possibility to print next to the text
Summary: Improve PRINTING capabilities of comments/notes: add possibility to print nex...
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
3.3.2 release
Hardware: Other All
: high enhancement
Assignee: Caolán McNamara
QA Contact: Joel Madero
URL:
Whiteboard: target:4.3.0
Keywords:
: 35902 38162 38245 44233 61989 66211 (view as bug list)
Depends on: 35902
Blocks:
  Show dependency treegraph
 
Reported: 2011-05-03 13:45 UTC by gleppert
Modified: 2015-04-29 16:39 UTC (History)
41 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description gleppert 2011-05-03 13:45:10 UTC
Printing or PDF-export of comments in Writer is still awful. As bug 35902 points out, on screen the comments look great and on paper they are printed after the entire document. 
However, bug 35902 does not go far enough. The notes should be printed next to the text in the right margin, similar how it is displayed on screen. This is a crucial enhancement to any serious Writer user in academic and professional environments.

Please refer to the great mockups in the OOo wiki:
http://wiki.services.openoffice.org/wiki/Notes2_Design_Printing, 
the related bug in the OOo wiki:
https://openoffice.org/bugzilla/show_bug.cgi?id=94514

Some more information here:
http://wiki.documentfoundation.org/Development/Enterprises_nice-to-have#Need_for_improved_collaboration_tools:_better_.22track_changes.22.2C_better_.22compare_documents.22.2C_better_.22printing_of_comments.22_needed
Comment 1 vitriol 2011-06-10 09:30:38 UTC
*** Bug 38162 has been marked as a duplicate of this bug. ***
Comment 2 Timur 2011-06-10 10:42:00 UTC
Sorry for posting a duplicate, I couldn't find it. I'll repeat a comment, because of point 2: 

1. Writer allows to view Comments in the margin, reducing the page to make
room. Leader lines link the Comments balloons to the text location to which
they refer. But, you cannot print Comments like this. 
You can print Comments only at the end of document or page, but this just
wastes paper. And it is difficult to relate Comments back to their location in the text.
So, we should have an option to print Comments in a margin right/left, in-line
with the text where they are positioned - WYSIWYP.

2. What should be taken into account is that Comments are normally all the way
to the right side of a page, so there should be some space for printing -
printer cuts a couple of millimeters. Interestingly enough, this is not solved
in Word 2010, so it's a real pain to print text with Comments.
Comment 3 Christoph 2011-07-10 13:42:53 UTC
*** Bug 38245 has been marked as a duplicate of this bug. ***
Comment 4 Christoph 2011-07-10 13:44:42 UTC
Since 38245 was a duplicate ...

* copying the info from 38245 to this issue
* adding EasyHack whiteboard tags
* adding olivier to the CC list
* added [PRINTING] keyword to the title

---
Issue: A highly (!) requested feature is to improve the printing of Writer
notes. Although the Notes2 activity implemented comments next to the text, the
printing of those notes is still very limited. You'll find a rather complete
specification at [1], and some more information on the main page Notes2 [2]. 

Current status:
* Rather complete specifications are available [1]

Required changes:
* Implement different preview and printing of comments in Writer
* Maybe: Update comments drop-down in printing dialog

Contact: Christoph Noack (Design Team)


References:

[1] Spec: Printing of Notes
http://wiki.services.openoffice.org/wiki/Notes2_Design_Printing

[2] Notes2 - Improved Notes for OOo
http://wiki.services.openoffice.org/wiki/Notes2
Comment 5 Björn Michaelsen 2011-12-23 12:04:55 UTC
[This is an automated message.]
This bug was filed before the changes to Bugzilla on 2011-10-16. Thus it
started right out as NEW without ever being explicitly confirmed. The bug is
changed to state NEEDINFO for this reason. To move this bug from NEEDINFO back
to NEW please check if the bug still persists with the 3.5.0 beta1 or beta2 prereleases.
Details on how to test the 3.5.0 beta1 can be found at:
http://wiki.documentfoundation.org/QA/BugHunting_Session_3.5.0.-1

more detail on this bulk operation: http://nabble.documentfoundation.org/RFC-Operation-Spamzilla-tp3607474p3607474.html
Comment 6 Timur 2011-12-24 10:12:08 UTC
The same issue on a new address: https://issues.apache.org/ooo/show_bug.cgi?id=94514. 
I consider this issue to be of "major" importance.
Comment 7 sasha.libreoffice 2012-02-21 05:19:48 UTC
Similar or duplicate:
Bug 44233 - Notes (comments) are not printable ASIDE text - PRINTING CONFIGURATION
Comment 8 Krotow 2012-02-28 06:44:32 UTC
Actually this isn't a bug, but feature request. However it's strange, why OO/LO page layout isn't printable as is with comment/track change boxes at right margin including lines from comment/change box to box source in text, as seen in edit mode. Seems OO/LO need two separate print modes - "as seen on screen", including comments and trac  and another with comments at end of page/document. This feature actually is badly needed - that is simpler to understand, when you show someone document with visible place of comment/change source in text.
Comment 9 Rainer Bielefeld Retired 2012-04-17 23:41:14 UTC
This is an enhancement request (but I agree, for many people an urgent one).
Comment 10 gleppert 2012-05-09 13:01:35 UTC
I don't see the reason why this enhancement should be dependent on 35902? 
Could anyone have a look at it and remove the dependency?

May I reiterate here that this enhancement is really an important one. Colleagues of mine just recently were deterred from this missing feature. As workaround, they first created screen shots of every single page of the document and printed them including comments. And then, they reverted back to Office 2010. Sad.
Comment 11 gleppert 2012-05-09 13:04:27 UTC
*** Bug 44233 has been marked as a duplicate of this bug. ***
Comment 12 gleppert 2012-05-09 13:07:29 UTC
adding CCs of duplicate bug to this one.
Comment 13 Joel Madero 2012-09-24 22:10:27 UTC
Adding myself as QA contact, going to see if we can get someone to take this one on. Thanks for keeping up with it
Comment 14 gleppert 2012-10-05 08:19:19 UTC
Thanks Joel, I am looking forward and hoping for the best. Advanced printing capabilities of comments is one of the enhancements which helps many people.
Comment 15 Stephan van den Akker 2012-11-30 09:59:40 UTC
Thanks Joel,

Don't use it much myself, but this comes up regularly in talks with users at my office. Would be great if these proposals are implemented!
Comment 16 Gerry 2013-01-12 11:44:45 UTC
For your information: "Advanced printing capabilities of comments in Writer" is the *Number 3* of the TopTen for Enhancement Requests on the Documentfoudation Wiki. 

Please see the votes on: http://wiki.documentfoundation.org/Vote_for_Enhancement#Top_Ten_of_Requests
Comment 17 Marco Menardi 2013-02-08 18:32:21 UTC
3.5 has come to end of life in its cycle so we are confirming the bug still exists in LibreOffice 4 and if it does, confirming that it is indeed a MAB. 
I have confirmed this bug on: Version 4.0 rc3
Moving to 3.6 MAB
Comment 18 Joel Madero 2013-02-08 18:36:47 UTC
I am actually removing this from MAB because it is an enhancement request, we decided some time ago that enhancement requests should not be on MAB list. Apologies for the inconvenience, hopefully a developer can pick it up at some point.
Comment 19 bugquestcontri 2013-03-01 03:11:59 UTC
@JOEL
Will removing this entry from MBA will effect the speed until this enhancement request will become reality?
The mock ups to be seen in 
http://wiki.openoffice.org/wiki/Notes2_Design_Printing
http://wiki.openoffice.org/wiki/Notes2
are looking great!

In AskLibO there was another request
http://ask.libreoffice.org/en/question/388/how-can-i-print-comments-inline-in-a-writer/?comment=13459#comment-13459

I too do miss this excellent functionality of WORD. 

I even volunteer for testing if the version can be installed parallel to my production version or as a portable version.
Comment 20 Joel Madero 2013-03-01 04:37:29 UTC
Honestly having it on MAB list is against policy as it's for bugs and never for enhancements.

As for an ETA on this - it's really hard to say. Please understand that most of our developers are volunteers and just do this as a hobby. Those who are paid by a company usually are tackling the daunting bugs that cause serious problems in our software. 

If you really want this done soon, might be good to try to find someone who will do it for a small fee. While TDF doesn't endorse any outside funding (ie. user does it on their own), I know one place that is gaining some popularity is http://www.freedomsponsors.org/, if enough people want it maybe you can raise enough to find someone to tackle it sooner. 

Otherwise, it's a "wait and see" - if a developer sees it and really wants to work on it (and of course has the time and the understanding of that code) it'll happen.

Best,
Joel
Comment 21 Joel Madero 2013-03-01 04:39:15 UTC
ah, just looked at the links. If AOO already has it, it means the code is there. Then it's a matter of bringing it over (which comes with its own complications but more feasible). 

I will investigate a bit more and get back to you ~ please disregard my last comment for the time being ;)
Comment 22 Joel Madero 2013-03-01 15:59:33 UTC
Apologies for spamming but comment 20 applies again. What we have in our code base is the same that AOO has, no work has been done since 2009 - so any work will be new and back to "no ETA"
Comment 23 gleppert 2013-03-02 19:58:27 UTC
Advanced printing capabilities of comments is now put on the list of ideas for Google Summer of Code 2013. I hope that some students finds this enhancement interesting and picks it / applies for it:

https://wiki.documentfoundation.org/Development/Gsoc/Ideas#Comments_improvements
Comment 24 Samuel Mehrbrodt (CIB) 2013-03-03 15:30:35 UTC
I created an Issue at FreedomSponsors for this:
http://www.freedomsponsors.org/core/offer/220/advanced-printing-capabilities-of-comments

There you can offer some money for the person who implements this. You pay only, when it's completed.
Comment 25 bfoman (inactive) 2013-03-08 17:27:52 UTC
*** Bug 61989 has been marked as a duplicate of this bug. ***
Comment 26 cpohle 2013-03-08 20:34:29 UTC
Hi everyone. I support this issue at FreedomSponsors (http://www.freedomsponsors.org/core/issue/209/advanced-printing-capabilities-of-comments) too.
Comment 27 spet1363 2013-05-08 23:04:00 UTC
Hi, I too am supporting this issue at FreedomSponsors. Hopefully we'll finally get this off the ground! (http://www.freedomsponsors.org/core/issue/209/advanced-printing-capabilities-of-comments)
Comment 28 Joel Madero 2013-05-08 23:06:22 UTC
Thanks for the support! 

Just an FYI...the current amount is ~1-2 hours paid labor for this enhancement, I suspect this is quite a bit less than the amount of time that will be required. Just trying to keep expectations realistic :)
Comment 29 Joel Madero 2013-05-08 23:21:21 UTC
Michael - any thoughts on this? Can you think of someone who has a little free time (haha...) and could tackle this. Seems like a popular request
Comment 30 bugquestcontri 2013-05-16 00:57:14 UTC
It might be worthwhile to have a look at https://bugs.freedesktop.org/show_bug.cgi?id=34355 comment 10.
Comment 31 Gerry 2013-06-26 07:31:45 UTC
In my opinion Joel's statement "Seems like a popular request" is very true. There are many people printing out or sending PDFs of documents with comments. This is simply not possible in LibreOffice and (in my environment) it is an (the sole?) important factor why people hate using LibreOffice. 

I hope someone has some free time to look at this enhancement. Looking forward to it.

A few numbers (to promote this enhancement request :-):

* 33 users CCed to this bug report
* It is voted as *Number 1* of the TopTen for Enhancement Requests on the Documentfoudation Wiki: http://wiki.documentfoundation.org/Vote_for_Enhancement#Top_Ten_of_Requests
* There are (until now just a few, so please consider) donations for this enhancement on Freedomsponsors: http://www.freedomsponsors.org/core/issue/209/advanced-printing-capabilities-of-comments
* 78 votes on the AOO bug system
Comment 32 Ken Biondi 2013-06-29 20:51:35 UTC
*** Bug 66211 has been marked as a duplicate of this bug. ***
Comment 33 Gerry 2013-10-01 08:11:05 UTC
I know that impatience in opensource projects is really a bad habit. I would like to ask for the chances that someone takes "Improve PRINTING capabilities of comments" and gets this enhancement into LibreOffice 4.2?

It is whiteboarded as "ProposedEasyHack". For many other enhancement requests, there is some kind of workaround. For this, actually no workaround exists, but to use Microsoft Office. LO is simply not competitive in this regard.

It is highly demanded, being
* #1 in the TopTen of requested enhancements
* having 38 people CCed here, and 79 CCed at AOO
* 6 duplicates
* having a small fundraising over at FreedomSponsors

Thanks a lot in advance!
Comment 34 Joel Madero 2013-10-01 13:42:29 UTC
Thanks for admitting that you understand that wanting is not doing ;) Unfortunately "proposedeasyhack" just means that someone from QA (usually with little or no technical skills) "think" it will be easy, this has no baring on if it's actually easy or not. This could easily be thousands of dollars worth of work and it is in fact an enhancement - compared with let's say a crasher bug or something which really prevents someone from using our product. 

Best bet is to try to find a developer to take this on as a pet project but always bare in mind that it's a thin line between trying to find a developer and just being annoying to a developer. 

In general we really try not to put comments on our bug tracker saying "I'd really really really like this feature, everyone wants it!" as it doesn't help us fix the problem at all and just clutters the bug tracker. I know some people have started a fundraiser over on the freedom sponsor site, perhaps if it's such a desired feature you can convince some people to put in a few bucks, if it gets to a reasonable number I'm pretty sure that a dev will take it on - last I saw it was less than $200, meaning it was a fraction of what the time is worth

Without direct action from those like you who really want the service, it's just a matter of patience and comes with no promises of when it'll be complete (if ever)
Comment 35 Gerry 2013-10-04 19:47:45 UTC
That's very encouraging: Tim contacted today the developers mailing list (http://lists.freedesktop.org/archives/libreoffice/2013-October/056202.html) telling that he wants to work on this enhancement. I am happy to hear this!

He is asking for code pointers. If someone here can be helpful for him, please contact him on the developers mailing list or to his email address.
Comment 36 Gerry 2013-10-08 21:30:54 UTC
Samuel sent some first code pointers for improved printing capabilities of comments: http://lists.freedesktop.org/archives/libreoffice/2013-October/056523.html

Maybe someone else is an expert in the areas who can help further?!?
Comment 37 Gerry 2013-12-10 20:57:20 UTC
update on the bug "Printing of comments": Nobody is currently working on this bug. Tim who was mentioned in comment 35 currently has other obligations. 
So, hopefully someone volunteers to work on this enhancement request.

There is a crowd-funding poll currently ongoing where the main listed item is this one here: "1. LibreOffice Printing Comments":
http://www.itsqueeze.com/2013/12/open-source-crowdfunding-poll/
Comment 38 Cédric Bosdonnat 2014-01-20 08:57:06 UTC
Restricted my LibreOffice hacking area
Comment 39 Joel Madero 2014-02-27 23:38:24 UTC
In order to limit the confusion between ProposedEasyHack and EasyHack and to make queries much easier we are changing ProposedEasyHack to NeedsDevEval.

Thank you and apologies for the noise
Comment 40 Joel Madero 2014-04-15 14:44:39 UTC
Nice Caolán :) Thanks for tackling this one. While you're digging in the code. I cc'ed you on bug 77488 just because you'll be digging around the comment code and it's related to comments (an enhancement I've seen by a couple people on ask site and user list). Feel free to remove yourself from CC if you won't be in that area of the code or if you don't want to tackle it.
Comment 41 Gerry 2014-04-16 10:14:23 UTC
@Caolán: That's great news! And super-quick: Yesterday you assign the bug to yourself and today you post the feature to the release notes: https://wiki.documentfoundation.org/ReleaseNotes/4.3#Writer

Thanks a lot!
Comment 42 Commit Notification 2014-04-16 10:16:43 UTC
Caolan McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=eb1c0480050a1328287c4a85468afbec50b0e29d

Resolves: fdo#36815 enable printing WYSIWYG sidewindow comments



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 43 Caolán McNamara 2014-04-16 10:19:31 UTC
Do not reopen this issue if the implementation here doesn't meet your expectations. File a new ones for any additional problems.
Comment 44 Gerry 2014-04-16 13:04:49 UTC
@Caolán: A quick question regarding this bug. Is the "place comments in margin" option also implemented in the PDF Export (as the second screenshot in your blog indicates) or shall I open a separate enhancement request for PDF export?
Comment 45 Caolán McNamara 2014-04-16 16:06:08 UTC
caolan->gerry: select the new "in margins" in tools->options->writer->print and on export to pdf they will be in the margins of the scaled content
Comment 46 Gerry 2014-04-16 19:52:55 UTC
gerry->caolan: Wouldn't it be better to have this also in File -> Export as PDF 

Currently ticking the option "Export comments" in that dialog exports the comments in the document as PDF comments. Hence, the new options in this dialog could be:

Export comments:
o Place in margins
o Place as PDF comments

I don't know whether printing and PDF exporting is similar from a development perspective, but this would be a good solution from the user perspective.

Thanks!
Comment 47 Mikeyy - L10n HR 2014-04-17 05:08:28 UTC
Thanks for this enhancement!
I'll check when 4.3 goes out, but by then this bug will be stone cold.

Is "place comments in margins" default behaviour when printing documents with comments? I think it should be, but just asking.
Comment 48 Stephan van den Akker 2014-04-17 07:39:47 UTC
Just checked on openSuSE 13.1 (64-bit ) in
 Version: 4.3.0.0.alpha0+
Build ID: 6a5de60d2086b595ab5b7b418fb590ebf6927050

I can confirm it works when printing, even if the text contains a
formula, bitmap or vector graphics next to the comment.
Comment 49 Commit Notification 2014-04-17 07:42:20 UTC
Caolan McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=fede08ac7d8b9d6c0abd2ba1b09fd3beb1c1b7e7

Related: fdo#36815 print the text highlight range as well



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 50 Stephan van den Akker 2014-04-17 11:33:42 UTC
Tested on openSuSE 13.1 (64-bit) with
LOdev Version: 4.3.0.0.alpha0+
Build ID: 7bda5f04a693c7943bc4201c11e73ca45bead661


Printing of the highlighted text range works. Nice work, Caolan.

I notice however that text ranges containing only empty lines (but
e.g. containing a formula) are highlighted on screen, but not on
paper. Is this intentional?



2014-04-17 9:42 GMT+02:00  <bugzilla-daemon@freedesktop.org>:
> Comment # 49 on bug 36815 from Commit Notification
>
> Caolan McNamara committed a patch related to this issue.
> It has been pushed to "master":
>
> http://cgit.freedesktop.org/libreoffice/core/commit/?id=fede08ac7d8b9d6c0abd2ba1b09fd3beb1c1b7e7
>
> Related: fdo#36815 print the text highlight range as well
>
>
>
> The patch should be included in the daily builds available at
> http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
> information about daily builds can be found at:
> http://wiki.documentfoundation.org/Testing_Daily_Builds
> Affected users are encouraged to test the fix and report feedback.
>
> ________________________________
> You are receiving this mail because:
>
> You are on the CC list for the bug.
Comment 51 Joel Madero 2014-04-17 16:59:08 UTC
Likely not intentional. Caolan - do you want us to open a separate bug report for that? You interested in being cc'ed on it?
Comment 52 Caolán McNamara 2014-04-17 17:27:29 UTC
yeah, file a new bug for whatever that problem is, with a test case and put me on cc
Comment 53 Gerry 2014-04-18 16:45:16 UTC
I added bug 77650 to "see also". It is a small enhancement request to improve the usability of PDF exporting documents with comments (in the margin).
Comment 54 Commit Notification 2014-04-24 13:14:26 UTC
Caolan McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9fd97266ce7dbeac33c93b6dace69d64c02d222c

Related: fdo#36815 center scaled comment page vertically



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 55 tommy27 2014-04-30 23:09:06 UTC
*** Bug 35902 has been marked as a duplicate of this bug. ***
Comment 56 Commit Notification 2014-05-06 14:58:49 UTC
Caolan McNamara committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=bb2d5c40e48d899bc39a18e6e038e067f6b9418b

Related: fdo#36815 clip overlarge comment contents



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.